/// <reference types="node" />
import { Server } from 'http';
import { Knex } from 'knex';
import { NetworkInterface } from './faces/network';
import Logging from './utils/logging';
import { WalletDB } from './db/wallet';
declare module 'koa' {
    interface BaseContext {
        connection: Knex;
        network: NetworkInterface;
        transactions: string[];
        dbPath: string;
        logging: Logging;
        fails: number;
        timestamp: number;
        txInBundle?: boolean;
    }
}
export default class ArLocal {
    private port;
    private dbPath;
    private persist;
    private fails;
    private log;
    private connection;
    private apollo;
    private server;
    private app;
    private router;
    private walletDB;
    constructor(port?: number, showLogs?: boolean, dbPath?: string, persist?: boolean, fails?: number);
    start(): Promise<void>;
    private startDB;
    stop(): Promise<void>;
    getServer(): Server;
    getNetwork(): NetworkInterface;
    getDbPath(): string;
    getWalletDb(): WalletDB;
}
