import { DataItemJson } from 'arweave-bundles';
import { TransactionType } from '../faces/transaction';
import { Knex } from 'knex';
export interface ANSTransaction {
    id: string;
    owner: string;
    content_type: string;
    target: string;
    tags: string;
}
export interface DatabaseTag {
    tx_id: string;
    index: number;
    name: string | undefined;
    value: string | undefined;
}
export declare const transactionFields: string[];
export declare function formatTransaction(transaction: TransactionType): Pick<any, string>;
export declare function formatAnsTransaction(ansTransaction: DataItemJson): Pick<any, string>;
export declare class TransactionDB {
    private connection;
    constructor(connection: Knex);
    getById(txId: string): Promise<any>;
    getUnminedTxs(): Promise<any[]>;
    getUnminedTxsRaw(): Promise<any[]>;
    deleteById(id: string): Promise<number>;
    mineTxs(block: string, unverifiedBundleTxs: string[]): Promise<number>;
}
