import { QueryTransactionsArgs, QueryBlockArgs, QueryBlocksArgs } from './types';
import { ISO8601DateTimeString } from '../utils/encoding';
import { TransactionHeader } from '../faces/arweave';
export declare const resolvers: {
    Query: {
        transaction: (_: any, queryParams: any, { connection }: {
            connection: any;
        }) => Promise<TransactionHeader>;
        transactions: (_: any, queryParams: QueryTransactionsArgs, { connection }: {
            connection: any;
        }) => Promise<{
            pageInfo: {
                hasNextPage: boolean;
            };
            edges: () => Promise<{
                cursor: string;
                node: any;
            }[]>;
        }>;
        block: (_: any, queryParams: QueryBlockArgs, { connection }: {
            connection: any;
        }) => Promise<any>;
        blocks: (_: any, queryParams: QueryBlocksArgs, { connection, network }: {
            connection: any;
            network: any;
        }) => Promise<{
            pageInfo: {
                hasNextPage: boolean;
            };
            edges: () => Promise<any>;
        }>;
    };
    Transaction: {
        tags: (parent: any) => any;
        recipient: (parent: any) => any;
        data: (parent: any) => {
            size: any;
            type: any;
        };
        quantity: (parent: any) => {
            ar: string;
            winston: any;
        };
        fee: (parent: any) => {
            ar: string;
            winston: any;
        };
        block: (parent: any) => {
            id: any;
            previous: any;
            timestamp: any;
            height: any;
        };
        owner: (parent: any) => {
            address: any;
            key: any;
        };
        parent: (parent: any) => {
            id: any;
        };
    };
    Block: {
        timestamp: (parent: any) => number;
    };
};
export interface Cursor {
    timestamp: ISO8601DateTimeString;
    offset: number;
}
export declare const newCursor: () => string;
export declare const encodeCursor: ({ timestamp, offset }: Cursor) => string;
export declare const parseCursor: (cursor: string) => Cursor;
